#!/usr/local/bin/perl -w
# pp --addfile=captureie.gld -gui -o captureie.exe captureie.pl
#
# Copyright (C) 2004 Norifumi SUNAOKA, All rights reserved.
#
# This is free software with ABSOLUTELY NO WARRANTY.
# Eۏ؁E쌠 (see http://nais.to/~yto/doc/zb/0002.html)

use strict;
use FileHandle;
use Win32 ();
use Win32::GUI;
use Win32::GUI::Loft::Design;
use Win32::CaptureIE;

eval {
	main();
};
Win32::GUI::MessageBox(0, "Error: $@", "Capture IE") if($@);

sub main {
	my $fileWindow = read_file('captureie.gld');
	my $objDesign = Win32::GUI::Loft::Design->newScalar($fileWindow) or 
			die("Could not open window file ($fileWindow)");
	
	my $win = $objDesign->buildWindow() or die("Could not build window ($fileWindow)");
	
	$win->Show();
	$win->tfSave->Text('capture.png');
	$win->tfUri->SetFocus();
	
	Win32::GUI::Dialog();
	
	return 1;
}

sub read_file {
	my $filename = shift;
	if ($INC{'PAR.pm'}) { # in PAR
		return PAR::read_file($filename);
	} else {
		my $fh = new FileHandle($filename);
		return join('', $fh->getlines());
	}
}

sub ::MainWnd_Terminate {
	return -1;
}

sub ::btnCapture_Click {
	defined(my $win = $Win32::GUI::Loft::window{MainWnd}) or return 1;
	my $uri = $win->tfUri->Text();
	my $save = $win->tfSave->Text();
	
	if ($uri eq '') {
		Win32::GUI::MessageBox(0, "Error: Input URI.", "Capture IE");
		$win->tfUri->SetFocus();
		return 1;
	}
	
	if ($save eq '') {
		Win32::GUI::MessageBox(0, "Error: Input file name.", "Capture IE");
		$win->tfSave->SetFocus();
		return 1;
	}
	
	StartIE( width => 1024, height => 768 );
	Navigate($uri);
	my $img = CapturePage();
	$img->Write($save);
	QuitIE();
	return 1;
}

sub ::btnExit_Click {
	return -1;
}
